#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */

#include "peri.h"
#include "usbdrv.h"

#define RQ_SET_LED         0
#define RQ_SET_LED_VALUE   1
#define RQ_GET_SWITCH      2
#define RQ_GET_LIGHT       3

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */
uint8_t minute;
uint8_t hour;
uint8_t start_m;
uint8_t start_h;
uint8_t end_m;
uint8_t end_h;
/*
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;
    // declared as static so they stay valid when usbFunctionSetup returns 
    static uint8_t switch_state;
    static uint16_t light;
    static uint8_t Svalue;
    if (rq->bRequest == 1)
    {
        uint8_t minute = rq->wValue.bytes[0];
        uint8_t hour  = rq->wIndex.bytes[0];
	uint8_t l_v = minute % 8;
	set_led_value(l_v);
        return 0;
    }
    if ( rq -> bRequest == 2)
    {
    	Svalue = start_h;
        usbMsgPtr = &Svalue;
	return 1;
    }
    if ( rq -> bRequest == 4)
    {
    	Svalue = start_m;
	usbMsgPtr = &Svalue;
	return 1;
    }
    if ( rq -> bRequest == 5)
    {
    	Svalue = end_h;
	usbMsgPtr = &Svalue;
	return 1;
    }	    
    if ( rq -> bRequest == 6)
    {
    	Svalue = end_m;
	usbMsgPtr = &Svalue;
	return 1;
    }
    // default for not implemented requests: return no data back to host 
    return 0;
}

*/
void wait_until_press(uint8_t pin)
{
	while(get_switch(pin) == 0)
	{
	  usbPoll();
	}

}
	
void set_zer0()
{
	set_led(0,0);
	set_led(1,0);
	set_led(2,0);
	set_led(3,0);
	set_led(4,0);
}
void start_puzzle()
{
	//set_led(0,0); set_led(1,0); set_led(2,0); set_led(3,0);
	set_zer0();
	uint8_t count = 0;
	uint8_t random_n = read_adc(PC5);
	while(count <= 10)
	{
		random_n = read_adc(PC5);
		if((random_n % 4 == 0 && count != 9) || count == 10)
		{
			set_zer0();
			set_led(0,1);		
			wait_until_press(0);
		}
		else if(random_n % 4 == 1)
		{
			set_zer0();
			set_led(1,1);
			wait_until_press(1);
		}
		else if(random_n % 4 == 2)
		{
			set_zer0();
			set_led(2,1);
			wait_until_press(2);
		}
		else
		{
			set_zer0();
			set_led(3,1);
			wait_until_press(3);
		}
		count = count+1;
	}	
	set_zer0();	return ;
}

void reset_time()
{
	start_h = -1;
	start_m = -1;
	end_h = -1;
	end_m =-1;
	return ;
}

uint8_t in_range()
{
	/*if(start_h == -1 || start_m == -1 || end_h == -1 || end_m == -1 ) return 0;
	if(start_h < hour && hour < end_h)
		return 1;
	else if(start_h == hour && minute >= start_m)
		return 1;
	else if(hour == end_h && minute <= end_m)
		return 1;
	return 0;*/
	uint16_t start = start_h*100 + start_m;
	uint16_t end = end_h * 100 + end_m;
	uint16_t current = hour * 100 + minute;
	if(start <= current && current <= end ) return 1;
	return 0;
}

int8_t count = 0;
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;
    /* declared as static so they stay valid when usbFunctionSetup returns */
    static uint8_t switch_state;
    static uint16_t light;
    static uint8_t Svalue;

	//_dalay_ms(100);
    if (rq->bRequest == 1)
    {
        minute = rq->wValue.bytes[0];
        hour  = rq->wIndex.bytes[0];
        //uint8_t l_v = minute % 8;
        //set_led_value(l_v);
   
	return 0;
    }
    if ( rq -> bRequest == 2)
    {
        Svalue = start_h;
        usbMsgPtr = &Svalue;
        return 1;
    }
	if ( rq -> bRequest == 4)
    {
        Svalue = start_m;
        usbMsgPtr = &Svalue;
        return 1;
    }
    if ( rq -> bRequest == 5)
    {
	Svalue = get_switch(4);
        usbMsgPtr = &Svalue;
        return 1;
    }       
    if ( rq -> bRequest == 6)
    {
        Svalue = in_range();
        usbMsgPtr = &Svalue;
        return 1;
    }

    if ( rq -> bRequest == 3)
    {
    	uint8_t index_0 = rq -> wIndex.bytes[0];
	uint8_t index_1 = rq -> wIndex.bytes[1];
	uint16_t index_2 = (index_1 << 8 )+ (index_0);
	uint8_t value_0 = rq -> wValue.bytes[0];
	uint8_t value_1 = rq -> wValue.bytes[1];
	uint16_t value_2 = (value_1 << 8 )+ value_0;
	start_h = index_2/100;
	start_m = index_2 % 100;
	end_h = value_2/100;
	end_m = value_2 % 100;
	if(start_h == 0 && start_m == 0 && end_h == 0 && end_m == 0)
	{
		set_led(4,0);
	}
	else
	{
		set_led(4,1);
	}
    }
    /* default for not implemented requests: return no data back to host */
    return 0;
}

void start_alert()
{
	start_h = 0;
	start_m = 0;
	end_h = 0;
	end_m = 0;
	set_led(4,0);
	set_led(5,0);
	start_puzzle();
	set_led(5,1);
}
/* ------------------------------------------------------------------------- */
int main(void) {
    init_peri();

    usbInit();

    /* enforce re-enumeration, do this while interrupts are disabled! */
    usbDeviceDisconnect();
    _delay_ms(300);
    usbDeviceConnect();
    start_h = 0;
    start_m = 0;
    end_h = 0;
    end_m = 0;
    hour = -1;
    minute = -1;
    /* enable global interrupts */
    sei();
    set_zer0();
    set_led(5,1);
    /* main event loop */
    while(1)
    {
         usbPoll();
	 //_delay_ms(100);
	 //start_puzzle();
	 if(in_range() == 1)
 	{
	  if(get_switch(4) == 0)
	   {
	     start_alert();
	   }
	}
    }

    return 0;
}

/* ------------------------------------------------------------------------- */
