from practicum import find_mcu_boards, McuBoard, PeriBoard
from time import sleep

devs = find_mcu_boards()

if len(devs) == 0:
    print("*** No practicum board found.")
    exit(1)

mcu = McuBoard(devs[0])
print("*** Practicum board found")
print("*** Manufacturer: %s" % \
        mcu.handle.getString(mcu.device.iManufacturer, 256))
print("*** Product: %s" % \
        mcu.handle.getString(mcu.device.iProduct, 256))
peri = PeriBoard(mcu)

count = 0
while True:
    peri.send_time()
    print("Hour Start : " + str(peri.get_time1()));
    print("Minute Start : "+ str(peri.get_time2()));
    print("PIR status : " + str(peri.get_time3()));
    print("In range status : " + str(peri.get_time4()));
    print("Time sented")
    sleep(1)


