from flask import Flask, request, render_template
from practicum import find_mcu_boards, McuBoard, PeriBoard
devices = find_mcu_boards()
mcu = McuBoard(devices[0])
peri = PeriBoard(mcu)


if len(devices) == 0:
    print("*** No practicum board found ***")
    exit(1)

app = Flask(__name__)

@app.route('/')

def my_form():
    return render_template('form_ex.html')

@app.route('/', methods = ['POST'])
def my_form_post():
    st = request.form['st']
    et = request.form['et']
    st = int(st)
    et = int(et)
    peri.set_period(st,et)
    return str(st) + '\n' + str(et)

if __name__=="__main__":
    app.run(debug=True, port = 8000 , host="0.0.0.0")
